package gui;

import javax.swing.JFrame;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import simulator.Network.ThresholdType;

import simulator.Network.Heuristics;

public class MainFrame extends JFrame{
	static final long serialVersionUID = 13467888765434L;
	JTextField nField;
	JTextField nAField;
	JTextField ZaaField;
	JTextField ZabField;
	JTextField ZbaField;
	JTextField ZbbField;
	JTextField thresholdField;
	JTextField initialField;
	JComboBox heuristics;
	JComboBox thrType;

	MainFrame(String s)
	{
		super(s);
		nField = new JTextField("500");
		nAField = new JTextField("50");
		ZaaField = new JTextField("20");
		ZabField = new JTextField("5");
		ZbaField = new JTextField("1");
		ZbbField = new JTextField("20");
		thresholdField = new JTextField("2");
		initialField = new JTextField("200");
		JButton simulateButton = new JButton("Simulate");
		
		setLayout(new GridLayout(11, 2, 3, 3));
		
		add(new JLabel(" N"));
		add(nField);
		
		add(new JLabel(" Na"));
		add(nAField);
		
		add(new JLabel(" Zaa"));
		add(ZaaField);
		
		add(new JLabel(" Zab"));
		add(ZabField);
		
		add(new JLabel(" Zba"));
		add(ZbaField);
		
		add(new JLabel(" Zbb"));
		add(ZbbField);
		
		add(new JLabel(" Threshold"));
		add(thresholdField);
		
		add(new JLabel(" n Initialy active"));
		add(initialField);
		
		add(new JLabel(" Heuristics"));
		heuristics = new JComboBox();
		for (simulator.Network.Heuristics heur : simulator.Network.Heuristics.values())
			heuristics.addItem(heur);
		add(heuristics);
		
		add(new JLabel(" Threshold Type"));
		thrType = new JComboBox();
		for (simulator.Network.ThresholdType thr : simulator.Network.ThresholdType.values())
			thrType.addItem(thr);
		add(thrType);
		
		add(simulateButton);
		
		ButtonHandler handler = new ButtonHandler();
		simulateButton.addActionListener(handler);
	}

	class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			JFrame simulationResults = new JFrame("The results of simulation");
			int n = Integer.parseInt(nField.getText());
			int nA = Integer.parseInt(nAField.getText());
			double pAA = Integer.parseInt(ZaaField.getText()) / (double)nA;
			double pAB = Integer.parseInt(ZabField.getText()) / (double)(n-nA);
			double pBA = Integer.parseInt(ZbaField.getText()) / (double)nA;
			double pBB = Integer.parseInt(ZbbField.getText()) / (double)(n-nA);
			int threshold = Integer.parseInt(thresholdField.getText());
			int nInitial = Integer.parseInt(initialField.getText());
			MainPanel p = new MainPanel(n, nA, pAA, pAB, pBA, pBB, 
					threshold, nInitial, (Heuristics)heuristics.getSelectedItem(),
					(ThresholdType)thrType.getSelectedItem());
			simulationResults.setSize(510, 550);
			simulationResults.add(p);
			simulationResults.setVisible(true);
		}
	}
}
